Subject: Re: bug#36447: 27.0.50; New "Unknown keyword" errors

From: Eli Zaretskii <[email-masked]>
Date: Fri, 05 Jul 2019 21:07:03 +0300

> From: Stefan Monnier <[email-masked]>
> Cc: Pip Cet <[email-masked]>,  [email-masked],  [email-masked],  [email-masked]
> Date: Fri, 05 Jul 2019 14:00:22 -0400
> 
> The problem is not rehashing in general, but rehashing a purecopied
> hash-table.  This should normally never be needed, since a purecopied
> hash-table should never be modified (no puthash/remhash should be
> applied to it), but sadly pdumper may need to recompute the hashes
> because objects's addresses may have changed between the dump and
> the reload.

Then perhaps pdumper should make a new object when it does that?

> His patch can/should be made slightly more efficient by only doing the
> Fcopy_sequence on those hash-tables that are in purespace.

I cannot say I like tweaking the GP implementation for the benefit of
what only the pdumper must do, it doesn't feel right.  Problems caused
by the pdumper should IMO be fixed in pdumper code.